(*^

::[paletteColors = 128; currentKernel; 
	fontset = title, nohscroll, center, bold,  24, "Times"; ;
	fontset = subtitle, nohscroll, center, bold,  18, "Times"; ;
	fontset = subsubtitle, nohscroll, center, bold,  14, "Times"; ;
	fontset = section, nohscroll, grayBox, bold,  18, "Times"; ;
	fontset = subsection, nohscroll, blackBox, bold,  14, "Times"; ;
	fontset = subsubsection, nohscroll, whiteBox, bold,  12, "Times"; ;
	fontset = text, nohscroll,  12;
	fontset = smalltext, nohscroll,  10, "Times"; ;
	fontset = input, nowordwrap, bold,  12, "Courier"; ;
	fontset = output, nowordwrap,  12, "Courier"; ;
	fontset = message, nowordwrap, R21845, G21845, B21845,  12, "Courier"; ;
	fontset = print, nowordwrap,  12, "Courier"; ;
	fontset = info, nowordwrap,  12, "Courier"; ;
	fontset = postscript, nowordwrap,  12, "Courier"; ;
	fontset = name, nowordwrap, nohscroll, italic, R21845, G21845, B21845,  11, "Times"; ;
	fontset = header,  10, "Times"; ;
	fontset = Left Header, nohscroll, cellOutline,  12;
	fontset = footer, center,  12;
	fontset = Left Footer, cellOutline, blackBox,  12;
	fontset = help, nohscroll,  14, "Times"; ;
	fontset = clipboard,  12;
	fontset = completions, nowordwrap,  16, "Courier"; ;
	fontset = special1, nowordwrap,  12;
	fontset = special2, nowordwrap, center,  12;
	fontset = special3, nowordwrap, right,  12;
	fontset = special4, nowordwrap,  12;
	fontset = special5, nowordwrap,  12;]
:[font = subtitle; inactive; startGroup; ]
A Tutorial For Solving
:[font = title; inactive; ]
Problems in Operations Research
:[font = text; inactive; center; endGroup; ]
by
Krishnapradad V. Kamisetty
CIM Systems Research Center
Arizona State University, Tempe, AZ 85287-5106
-- Now at Intel, Phoenix --
:[font = section; inactive; startGroup; ]
The Assignment Model
:[font = subsection; inactive; ]
Introduction
:[font = text; inactive; ]
This problem consists of allocating some resources to some operating patterns in such a way that the costs of the assignments are minimized, each resource is assigned exactly once. Hungarian algorithm is used to solve the problem.

This tutorial assumes that the given problem will be in a square matrix form and that the values given in the matrix are COSTS.  If the original problem is given in terms of  profits, the user will have to multiply the profit numbers by -1 and then use the tutorial.
:[font = subsection; inactive; ]
Example1
:[font = text; inactive; ]
This section steps you through an example problem.  The following subsections are arranged logically so that you can perceive the operations performed to arrive at an optimum solution. Please note that there may typically be many more alternate optimum solutions.
:[font = subsubsection; inactive; ]
Loading the Function Definitions
:[font = input; ]
<<hungarian.m
:[font = subsubsection; inactive; ]
Initialization
:[font = input; startGroup; ]
initialization
:[font = print; inactive; endGroup; ]
INITIALIZATION DONE
:[font = subsubsection; inactive; ]
Data Input Process
:[font = input; startGroup; ]
inputphase
:[font = print; inactive; endGroup; ]
2   10  9
 
15  4   14
 
13  14  16
:[font = subsubsection; inactive; ]
Row Reduction by the minimum of the row elements
:[font = input; startGroup; ]
rowreduction
:[font = print; inactive; endGroup; ]
0   8   7
 
11  0   10
 
0   1   3
:[font = subsubsection; inactive; ]
Column Reduction by the minimum of the column elements
:[font = input; startGroup; ]
columnreduction
:[font = print; inactive; endGroup; ]
0   8   4
 
11  0   7
 
0   1   0
:[font = subsubsection; inactive; ]
Checking for all the zeroes that the matrix has at this point
:[font = input; startGroup; ]
zerocheck
:[font = print; inactive; endGroup; ]
11
22
31
33
:[font = subsubsection; inactive; ]
What kind of solution do we have now?
:[font = input; startGroup; ]
whatdoithink
:[font = print; inactive; endGroup; ]
POSSIBLE OPTIMUM goto OPTIMAL function
:[font = subsubsection; inactive; ]
Check for Optimum solution and find the SOLUTION
:[font = input; startGroup; ]
optimal
:[font = print; inactive; endGroup; ]
OPTIMAL
11
22
33
:[font = subsection; inactive; ]
Example2
:[font = subsubsection; inactive; ]
Loading the Function Definitions
:[font = input; ]
<<hungarian.m
:[font = subsubsection; inactive; ]
Initialization
:[font = input; startGroup; ]
initialization
:[font = print; inactive; endGroup; ]
INITIALIZATION DONE
:[font = subsubsection; inactive; ]
Data Input Process
:[font = input; startGroup; ]
inputphase
:[font = print; inactive; endGroup; ]
2   10  9   7
 
15  4   14  8
 
13  14  16  11
 
4   15  13  19
:[font = subsubsection; inactive; ]
Row Reduction by the minimum of the row elements
:[font = input; startGroup; ]
rowreduction
:[font = print; inactive; endGroup; ]
0   8   7   5
 
11  0   10  4
 
2   3   5   0
 
0   11  9   15
:[font = subsubsection; inactive; ]
Column Reduction by the minimum of the column elements
:[font = input; startGroup; ]
columnreduction
:[font = print; inactive; endGroup; ]
0   8   2   5
 
11  0   5   4
 
2   3   0   0
 
0   11  4   15
:[font = subsubsection; inactive; ]
Checking for all the zeroes that the matrix has at this point
:[font = input; startGroup; ]
zerocheck
:[font = print; inactive; endGroup; ]
11
22
33
34
41
:[font = subsubsection; inactive; ]
What kind of solution do we have now?
:[font = input; startGroup; ]
whatdoithink
:[font = print; inactive; endGroup; ]
POSSIBLE OPTIMUM goto OPTIMAL function
:[font = subsubsection; inactive; ]
Check for Optimum solution and find the optimal solution
:[font = input; startGroup; ]
optimal
:[font = print; inactive; endGroup; ]
NONOPTIMAL still go to Nonoptimal
:[font = subsubsection; inactive; ]
Modify the matrix by the HUNGARIAN way 
:[font = input; startGroup; ]
nonoptimal
:[font = output; output; inactive; endGroup; ]
TableForm[{{0, 6, 0, 3}, {13, 0, 5, 4}, {4, 3, 0, 0}, 
   {0, 9, 2, 13}}]
;[o]
0   6   0   3
 
13  0   5   4
 
4   3   0   0
 
0   9   2   13
:[font = subsubsection; inactive; ]
Check for the zeroes again in the new matrix
:[font = input; startGroup; ]
zerocheck
:[font = print; inactive; endGroup; ]
11
13
22
33
34
41
:[font = subsubsection; inactive; ]
Check for the optimum solution again
:[font = input; startGroup; ]
optimal
:[font = print; inactive; endGroup; ]
OPTIMAL
13
22
34
41
:[font = subsection; inactive; ]
Tutorial for solving a given problem
:[font = subsubsection; inactive; ]
Introduction
:[font = text; inactive; ]
This tutorial allows you to solve any assignment problem you have, of any order. You will have to start the program by first clicking the INITIALIZATION cell. This clears out all the previous results stored.  Then you should click the DATA INPUT cell.  First, you will be asked to give the order of the matrix. i.e. 3,4,5 etc.

Then, click the ROW REDUCTION, COLUMN REDUCTION, ZEROCHECK, WHATDOITHINK  cells in that order. Depending on the message given by the last function, you will want to go either to OPTIMAL or NONOPTIMAL cell. If you are directed to OPTIMAL and OPTIMAL says "optimal", you will get the final solution and you are done. But, if you get the message "Non optimal still...go to NONOPTIMAL", then click NONOPTIMAL, ZEROCHECK, OPTIMAL in that order. Repeat the 3 function process until you are done. The Tutorial has appropriate messages at every point and so, please rest assured that you WILL get the solution even if you do not clearly comprehend what was just said in these two paragraphs. 

Whenever the tutorial says click the command etc., you are expected to place the cursor anywhere in that command line and press "Enter" ...not "Return" .  Good Luck!
:[font = subsubsection; inactive; ]
STEP1 : LOAD THE DEFINITIONS
:[font = text; inactive; ]
This is an essential step before solving any problem using this tutorial. This step loads the necessary function definitions stored elsewhere.
:[font = input; ]
<<hungarian.m
:[font = subsubsection; inactive; ]
STEP2 : INITIALIZATION 
:[font = text; inactive; ]
This step lets you clear out all the previous definitions and results and start afresh. This will have to be performed every time you would like to solve a new problem or if you would like to re-solve the problem that has been just solved.
:[font = input; ]
initialization
:[font = subsubsection; inactive; ]
STEP3 : DATA INPUT
:[font = text; inactive; ]
This step when performed, opens a dialog box for you to input the order of the matrix and the cost elements of the matrix.  You will have to press "Return" and not "Enter" after each input. The cost elements should be entered row by row. i.e. If you have matrix of order 2, then you will enter the elements in the following order:

row 1 & Column 1
row 1 & Column 2
row 2 & Column 1
row 2 & Column 2

If you make a mistake in inputting the numbers, go back to INITIALIZATION and perform that and the following steps once again. You don't have to LOAD the definitions again, though.
:[font = input; ]
inputphase
:[font = subsubsection; inactive; ]
STEP4 : ROW REDUCTION
:[font = text; inactive; ]
This step finds the minimum element in each row and subtracts that number from each element of the respective row.These are nothing but valid matrix row operations which point at a possible minimum cost optimum solution.
:[font = input; ]
rowreduction
:[font = subsubsection; inactive; ]
STEP5 : COLUMN REDUCTION
:[font = text; inactive; ]
This step finds the minimum element in each column and subtracts that number from each element of the respective column.These are nothing but valid matrix column operations which point at a possible minimum cost optimum solution.
:[font = input; ]
columnreduction
:[font = subsubsection; inactive; ]
STEP6 : CHECKING FOR ZEROES
:[font = text; inactive; ]
This step when performed, enumerates all the zeroes in the matrix resulting from the row and column operations in steps 4 and 5. The rest of the tutorial involves manipulating zeroes to see if we have an optimum solution or to tell us what to do if we still have a nonoptimum solution.
:[font = input; ]
zerocheck
:[font = subsubsection; inactive; ]
STEP7 : WHERE DO WE GO NEXT?
:[font = text; inactive; ]
This step is designed to aid you to know where to go next.  When performed, you will get a message. If you get, "Possible Optimum go to OPTIMAL function" then click the input command in STEP8. If you get, "Non Optimal yet..go to NONOPTIMAL function", then click the input command in STEP9.  You will be directed further by those steps till you arrive at a final OPTIMAL solution.
:[font = input; ]
whatdoithink
:[font = subsubsection; inactive; ]
STEP8 : CHECKING FOR OPTIMUM SOLUTION
:[font = text; inactive; ]
This step checks for an optimum solution and if it finds one comes back and tells you
"OPTIMAL" followed by the solution in terms of the row and column numbers. If it tells you "nonoptimal still...go to NONOPTIMAL", then you should click the command in STEP9.
:[font = input; ]
optimal
:[font = subsubsection; inactive; ]
STEP9 : MODIFICATION OF THE MATRIX
:[font = text; inactive; ]
This step modifies the matrix from the STEP5 according to the HUNGARIAN Algorithm. At the end of the process, you will see the resulting matrix. You will have to click the command in STEP6 again followed by STEP7.  Just follow the directions from there on in an iterative fashion until you arrive at an optimum solution.
:[font = input; ]
nonoptimal
:[font = subsubsection; inactive; ]
FINAL STEP 
:[font = text; inactive; ]
At this point, you will have an OPTIMUM solution in your hands.  If you want to save the calculations for yourself, then choose "SAVE AS" in the "WINDOW" menu and give the file a new name of your choice.

If you just want to quit without saving anything, then just choose "QUIT" in the main menu OR close the window by clicking on X and clicking NO in the dialog box that appears.

Thank you for using this tutorial!
:[font = subsection; inactive; endGroup; ]
Implementation Aspects
:[font = subsubsection; inactive; ]
Initialization Function
:[font = input; ]

initialization := Block[{},
                        k=.;v=.;g=.;h=.;i=1;j=1;
                        Clear[cost,min,rred,cmin,cred,check,check1];
                        
                        Print[INITIALIZATION," ",DONE]
                       ]
:[font = subsubsection; inactive; ]
Input Data Function
:[font = input; ]
inputphase := Block[{},
                       n=Input["What is the square matrix order?"];
                       Do[cost[xx,yy]=Input["Enter row by row,one
                                              element at a time"],
                                              {xx,n},{yy,n}
                        ];
                       costmatrix = Table[cost[y,z], {y,n},{z,n}];
                       Print[TableForm[costmatrix]]
                   ]
:[font = subsubsection; inactive; ]
Row Reduction Function
:[font = input; ]
rowreduction := Block[{},
                        Clear[min,rred];
                        Do[min[k] = Min[costmatrix[[k]]],{k,1,n}];
                        Do[ rred[k] = costmatrix[[k]] - min[k],{k,1,n}];
                        rowreducedmatrix = Table[rred[k],{k,n}];
                        Print[TableForm[rowreducedmatrix]] 
                     ]
:[font = subsubsection; inactive; ]
Column Reduction Function
:[font = input; ]
columnreduction := Block[{},
                          Clear[cmin,cred];
                          p = Transpose[rowreducedmatrix]; 
                          Do[cmin[k] = Min[p[[k]]],{k,1,n}];
                          Do[cred[k] = p[[k]] - cmin[k],{k,1,n}];
                          q = Table[cred[k],{k,n}];
                          colreducedmatrix=Transpose[q];
                          Print[TableForm[colreducedmatrix]]
                       ]
:[font = subsubsection; inactive; ]
Zero Check Function
:[font = input; ]
zerocheck := Block[{},
                      Clear[check,check1];v=.;k=.;g=.;h=.;i=1;j=1;
                      Do[
                         If[ colreducedmatrix[ [k,v] ] == 0, check[i]=k;
                             check1[j]=v;Print[k,v];i++;j++ 
                           ],{k,n},{v,n}
                        ];
                      zerorows=Table[check[g],{g,1,i-1}];
                      zerocols=Table[check1[h],{h,i-1}];
                   ]
:[font = input; ]

:[font = subsubsection; inactive; ]
What Do I Think Function?
:[font = input; ]
whatdoithink := 
               If[Length[zerorows]>=n,
                  Print[POSSIBLE," ",OPTIMUM," ",goto," ",OPTIMAL," ",
                  function],
                  Print[NOT," ",OPTIMUM," ",YET," ",goto," ",
                  NONOPTIMAL," ",function]
                 ] 
:[font = subsubsection; inactive; ]
Assignment Function
:[font = input; ]
assignment := Block[{l1,l2,s,x={},y={}},
                     If[iter != 0,
                          t=Append[t,e[[iter]]];
                          u=Append[u,f[[iter]]];
                          l1=Length[e];
                          x={};y={};x=e;y=f;
                          Do[If[First[x] == Last[t], 
                            e=Drop[e,{1,1}];x=RotateLeft[x];
                            f=Drop[f,{1,1}];y=RotateLeft[y],
                            x=RotateLeft[x];y=RotateLeft[y];
                            e=RotateLeft[e];f=RotateLeft[f] ],{s,l1}
                            ];
                          x={};y={};x=e;y=f;l2=Length[e];
                          Do[If[First[y] == Last[u],
                               f=Drop[f,{1,1}];y=RotateLeft[y];
                               e=Drop[e,{1,1}];x=RotateLeft[x],
                               y=RotateLeft[y];x=RotateLeft[x];
                               f=RotateLeft[f];e=RotateLeft[e] ],{s,l2}
                            ]
                      ]; (* end of outermost IF *)
                      If[Length[e] == 0,iter=0,iter=1] 
                    ] (* end of BLOCK *)  
:[font = subsubsection; inactive; ]
Optimal Check Function
:[font = input; ]
optimal := Block[{soln,l,r},
                   l=Length[zerorows];objective=0;
                   For[i=1,i<=l,i++,
                        t={};u={};tu={};
                        e={};f={};e=zerorows;f=zerocols;iter=i;
                        Do[assignment,{soln,n}];
                        tu=Intersection[t,u];
                        If[Length[tu] == n, Print[OPTIMAL];
                                         Do[Print[t[[r]],u[[r]]];
                        objective += costmatrix[[t[[r]],u[[r]]]],{r,n}];
                        Print[OBJECTIVE," ",COST," ",IS," ",objective];
                                         Break[] 
                          ]
                      ];
                    If[i==l+1,Print[NONOPTIMAL," ",still," ",go," ",
                                to," ",Nonoptimal]]
                  ]
                                         
:[font = subsubsection; inactive; ]
Non Optimal Modification Function
:[font = input; ]
nonoptimal := 
Block[ {z,rows={},cols={},uncovered={},common={},iteru,iterc,q2={}},
          z=n;q2=colreducedmatrix;timen=1;timen++;
          While[z != 0,
             For[row=1,row <= n,row++,
               If[FreeQ[rows,row],
                 If[Count[q2[[row]],0] ==z, rows=Append[rows,row];
                                        q2[[row]]=q2[[row]]+1
                                             ] (*endif*)
                  ] (*end outer If *)
                ]; (* end of For loop *)
                								
                 q2=Transpose[q2];
                 For[col=1,col<=n,col++,
                   If[FreeQ[cols,col],
                    If[Count[q2[[col]],0] ==z, cols=Append[cols,col];
                                           q2[[col]]=q2[[col]]+1
                                            ](*endif*)
                     ] (*end outer If *)
                    ]; (*end of FOR loop *)
                  q2=Transpose[q2];
              z-- ]; (*end of WHILE loop *) 
      For[row=1,row<=n,row++,
         For[col=1,col<=n,col++,
             If[FreeQ[rows,row] && FreeQ[cols,col],
                uncovered=Append[uncovered,colreducedmatrix[[row,col]]]
               ];
             If[MemberQ[rows,row] && MemberQ[cols,col],
                common=Append[common,colreducedmatrix[[row,col]]]
               ]
            ] (* end of inner For loop *)
         ]; (* end of outer For loop *)
minuncov=Min[uncovered];iteru=1;iterc=1;
For[row=1,row<=n,row++,
 For[col=1,col<=n,col++,
   If[FreeQ[rows,row] && FreeQ[cols,col] && iteru<=Length[uncovered],
        colreducedmatrix[[row,col]] = uncovered[[iteru]]-minuncov;
        iteru++
     ];
   If[MemberQ[rows,row] && MemberQ[cols,col] && iterc <= Length[common],
        colreducedmatrix[[row,col]] = common[[iterc]]+minuncov;
        iterc++
     ]
    ] (* end of inner for loop *)
   ];  (* end of outer for loop *)  
 TableForm[colreducedmatrix]
 
 ] (*end of Block *)          
:[font = subsubsection; inactive; ]
Command for Saving the function definitions in a FILE.m (Change the filename)
:[font = input; ]
Save["hungarian.m",initialization,inputphase,rowreduction,
        columnreduction,zerocheck,whatdoithink,assignment,
        optimal,nonoptimal]
:[font = subsubsection; inactive; ]
 Command for CLEARING the function definitions 
:[font = input; ]
Clear[initialization,inputphase,rowreduction,
        columnreduction,zerocheck,whatdoithink,assignment,
        optimal,nonoptimal]
^*)